/* 
 * File:   main.cpp
 * Author: Kristine Ivarsøy and Ida Elise Solhaug
 *
 * Created on April 3, 2014, 8:10 PM
 */

#include <cstdlib>
#include <cstdio>
#include "bbclass.hpp"
#include "workerclass.hpp"

using namespace std;


int main(int argc, char** argv) {
    
    //Start the MPI environment
    MPI::Init();
    MPI::Intracomm communicator;
    
    communicator = MPI::COMM_WORLD;
    
    MPI::Request request;
    MPI::Status status;
    
    if (communicator.Get_rank()==0){
        cout<<"0: Are you ready?"<<endl;
        int message =1;
        for (int i=1;i <communicator.Get_size();i++) {
            request = communicator.Issend(&message, 1 , MPI::INT, i, 0);
            request.Wait(status); 
        }
    }
    
    else {
        int vessel;
        // communicator.Iprobe(0, MPI::ANY_TAG, status);
        communicator.Recv(&vessel, 1, MPI::INT, 0, 0, status);
        if(vessel==1)
        cout<<communicator.Get_rank()<<": I am ready!"<<endl;
        else
        cout<<communicator.Get_rank()<<": am I ready?: "<<vessel<<endl;
    }

    // Start the solver
    XPRSinit(NULL);
    
    cout<<communicator.Get_rank()<<": fileinput : "<<argv[1]<<endl;

    // If I am the master, I create a bbclass object
    if (communicator.Get_rank() == 0){
        //Create a bbclass object
        bbclass instance;
        instance.initialize(argv[1], communicator);
        //Call the bbclass routine to solve
        instance.optimize();
        
    //  Else, I am a worker,
    } else {
        // Create a workerclass object
        workerclass instance;
        instance.initialize(argv[1], communicator);
        // Call the worker routing to solve
        instance.optimize();
    }
    
    // End the solver
    XPRSfree();
    
    // End the MPI environment
    MPI::Finalize();

    return 0;
}

