/* 
 * File:   nodeclass.cpp
 * Author: Kristine Ivarsøy and Ida Elise Solhaug
 * 
 * Created on April 8, 2014, 9:08 PM
 */
 
#include "nodeclass.hpp"
# include <iostream>
#include <stdio.h>
#include <float.h>

using  namespace std;

int nodeclass::master_tag=0;

nodeclass::nodeclass() {
}
 
nodeclass::nodeclass(const nodeclass& orig) {
}
 
nodeclass::~nodeclass() {
}
 
void nodeclass::initialize(int *fixed_array, int size, double lbound){
    num_bins = size;   // every node must know how many binary variables the problem have
    fixed_binaries = new int[size];     //allocate memory for the array with the status of the binary variables
    for(int i=0;i<num_bins; i++) fixed_binaries[i]=fixed_array[i];      //fill in the status of the binary variables
    value = DBL_MAX;    // assign a preliminary value of the node to the maximum positive number for doubles
    status = 'U';       // assign a preliminary status of the node as unsolved
    lower_bound = lbound; // set lower bound as lbound
    node_tag = master_tag; // set the id as the current number of master_tag, saying how many nodes have been created so far
    master_tag++; //increment the number of nodes created
}

void nodeclass::get_binaries(int* array, int size){
    for(int i=0; i< size;i++) {
        array[i]=fixed_binaries[i];
    }
}